<?php

require_once(dirname(__FILE__) . '/parspal_api_helper.class.php');

$viewname = 'form';
$title = 'فرم پرداخت';

if($config->currency != 'IRR' && $config->currency != 'IRT')
{
    $viewname = 'message';
    $viewbag['title'] = 'خطا !';
    $viewbag['message'] = 'مقدار واحد پول می بایست یکی از مقادیر IRR و یا IRT تعیین شود .';
    return;
}

if(isset($_REQUEST["p"]) || isset($_REQUEST["price"]))
{
    if(isset($_REQUEST["p"]) && intval($_REQUEST["p"]) > 0)
    {
        $config->fixedPrice = intval($_REQUEST["p"]);
    }
    if(isset($_REQUEST["price"]) && intval($_REQUEST["price"]) > 0)
    {
        $config->fixedPrice = intval($_REQUEST["price"]);
    }
}
if(isset($_REQUEST["d"]) || isset($_REQUEST["description"]))
{
    if(isset($_REQUEST["d"]) && $_REQUEST["d"] != '')
    {
        $config->fixedDescription = $_REQUEST["d"];
    }
    if(isset($_REQUEST["description"]) && $_REQUEST["description"] != '')
    {
        $config->fixedDescription = $_REQUEST["description"];
    }
}

if(isset($_GET["action"]))
{
    if($_GET["action"] == "connect")
    {
        if($config->fixedPrice <= 0 && !isset($_POST['price']))
        {
            $viewname = 'message';
            $viewbag['title'] = 'خطا !';
            $viewbag['message'] = 'مقداری برای مبلغ پرداخت تعیین نشده است !';
            return;
        }

        if($config->fixedPrice > 0)
            $amount = $config->fixedPrice;
        else
            $amount = $_POST['price'];
        
        $first_name = isset($_POST['first_name']) ? $_POST['first_name'] : null;
        $last_name = isset($_POST['last_name']) ? $_POST['last_name'] : null;
        $mobile = isset($_POST['mobile']) ? $_POST['mobile'] : null;
        $email = isset($_POST['email']) ? $_POST['email'] : null;
        $description = isset($_POST['description']) ? $_POST['description'] : null;
        
        $callbackUrl =  (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]".parse_url($_SERVER["REQUEST_URI"], PHP_URL_PATH)."?action=callback";
        
        $papi = new ParsPal_API_Helper($config->apiKey);
		$rapi = $papi->paymentRequest(array(
				'amount'      => $amount,
				'description' => $description,
				'reserve_id'  => $amount,
				'return_url'  => $callbackUrl,
                'currency'    => $config->currency,
				'payer'       => array(
				'name'        => $first_name .' ' . $last_name,
				'email'       => $email,
				'mobile'      => $mobile,
		)));
		if ($rapi)
		{
			$viewname = 'connect';
            $viewbag['url'] = $papi->paymentUrl;
		}
		else
		{
			$viewname = 'message';
			$viewbag['title'] = 'بروزمشکل !';
			$viewbag['message'] = $papi->error;
		}
    }
    else if($_GET["action"] == "callback")
    {
        $title = 'نتیجه پرداخت';
        $viewname = 'result';
        $viewbag['status'] = false;
        $viewbag['backlink'] = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]".parse_url($_SERVER["REQUEST_URI"], PHP_URL_PATH);
        $papi = new ParsPal_API_Helper($config->apiKey);
        if(!isset($_POST['status']))
        {
            $viewbag['message'] = 'اطلاعاتی از سمت درگاه دریافت نشده است !';
        }
        else if($papi->checkStatusCode($_POST['status']))
        {
            $receipt_number = $_POST['receipt_number'];
            if($config->fixedPrice > 0)
                $amount = $config->fixedPrice;
            else
                $amount = $_POST['reserve_id'];
            $rapi = $papi->paymentVerify($receipt_number, $amount,$config->currency);
            if ($rapi)
            {
                $viewbag['status'] = true;
            }
            else
            {
            	$viewbag['message'] = $papi->error;
            }
            $viewbag['receipt_number'] = $receipt_number;
            $viewbag['price'] = $amount;
        }
        else
        {
            $viewbag['message'] = 'اطلاعات مبنی بر پرداخت موفق دریافت نشده است'.'<br>'.$papi->error;
            $viewbag['price'] = isset($_POST['reserve_id']) ? $_POST['reserve_id'] : '0';
        }
    }
}

?>